/*
 * Copyright  2005 Sun Microsystems Inc. All rights reserved. Use is subject to license terms.
 *  
 */

package com.sunlabs.archsim.fleet.ships.tokenadder;

import com.sunlabs.archsim.base.simulation.Delay;
import com.sunlabs.archsim.fleet.common.Data;
import com.sunlabs.archsim.fleet.common.OutputFunction;
import com.sunlabs.archsim.fleet.common.Payload;
import com.sunlabs.archsim.gasp.terminals.InputTerminal;
import com.sunlabs.archsim.globals.Globals;

/** Vacuous function used to acknowldge that the action has fired */ 
class TokenFunction extends OutputFunction {

        /* reference to teh intput terminal acknowledged by this function */
        InputTerminal in;
    
	/** Global settings */
	protected Globals globals= Globals.getInstance();
	
	public TokenFunction(InputTerminal in) {
		this("TokenFunction", in);
	}
	
	public TokenFunction(String name, InputTerminal in) {
		super(name);
		Integer fDelay= globals.intValue(AdderDefaults.ACK_DELAY);
		functionDelay= (fDelay != null)
				? new Delay(fDelay.intValue())
				: AdderDefaults.ACK_DELAY_DEF;
                
                this.in= in;
	}
	
	public Data value() {
                // depending on the validity of the data on this input, output valid or OOB token
                if (((Payload)in.getData()).data.valid) {
                    return new Data(true);
                } else {
                    return new Data(false);
                }
	} // value
	
} // AckFunction